#!/bin/bash

#
#usage
# curl http://192.168.80.10:8929/allan/pnv/raw/master/build-edison.sh > pnv.sh && bash pnv.sh setup



export TUNEX="10"

setupDeps(){
    cd
curl http://192.168.80.10:8929/allan/pnv/raw/master/edison-oaps.sh > /tmp/edison-oaps.sh
bash /tmp/edison-oaps.sh
apt update

apt-cache search pcre
apt-get install -y libpcre3-dev git build-essential python-dev nodejs-dev cmake libjson-c-dev 
cd
   
}

setupSwig(){
 cd   
  rm -fr swig
git clone https://github.com/swig/swig.git

cd swig
apt-get install automake
./autogen.sh
./configure
apt-get install bison flex
make
make install

cd  
}

setupMraa(){
 cd
 #apt-get install -y cmake-data=2.8.11.1-1~bpo70+1 cmake=2.8.11.1-1~bpo70+1 
apt-get install -y cmake-3.2.2
rm -fr mraa
cd /root
git clone https://github.com/intel-iot-devkit/mraa.git
mkdir mraa/build
cd mraa/build
#cmake -DBUILDSWIGNODE=OFF -DBUILDSWIGJAVA=ON -DCMAKE_INSTALL_PREFIX:PATH=/usr ..
cmake -DBUILDARCH=arm -DBUILDSWIGPYTHON=ON -DCMAKE_INSTALL_PREFIX:PATH=/usr ..
make
make install

cd
    
}

setupWifi(){
  
 (
dmesg -D
echo Scanning for wifi networks:
ifup wlan0
wpa_cli scan
echo -e "\nStrongest networks found:"
wpa_cli scan_res | sort -grk 3 | head | awk -F '\t' '{print $NF}' | uniq
set -e
echo -e /"\nWARNING: this script will back up and remove all of your current wifi configs."
read -p "Press Ctrl-C to cancel, or press Enter to continue:" -r
echo -e "\nNOTE: Spaces in your network name or password are ok. Do not add quotes."
read -p "Enter your WIFI name: " -r
SSID=$REPLY
read -p "Enter your WIFI password: " -r
PSK=$REPLY
cd /etc/network
cp interfaces interfaces.$(date +%s).bak
echo -e "auto lo\niface lo inet loopback\n\nauto usb0\niface usb0 inet static\n  address 10.11.12.13\n  netmask 255.255.255.0\n\nauto wlan0\niface wlan0 inet dhcp\n  wpa-conf /etc/wpa_supplicant/wpa_supplicant.conf" > interfaces
echo -e "\n/etc/network/interfaces:\n"
cat interfaces
cd /etc/wpa_supplicant/
cp wpa_supplicant.conf wpa_supplicant.conf.$(date +%s).bak
echo -e "ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev\nupdate_config=1\nnetwork={\n  ssid=\"$SSID\"\n  psk=\"$PSK\"\n}" > wpa_supplicant.conf
echo -e "\n/etc/wpa_supplicant/wpa_supplicant.conf:\n"
cat wpa_supplicant.conf
echo -e "\nAttempting to bring up wlan0:\n"
ifdown wlan0; ifup wlan0
sleep 10
echo -ne "\nWifi SSID: "; iwgetid -r
cd


)

}


case "$1" in
 insta)
 apt update
 

   ;;
 setup)
cd
setupDeps
setupSwig
setupMraa
cd


  ;;
 wifi)
setupWifi

  ;;
 start)
 cd
 rm -fr pnv ; mkdir pnv ; cd pnv
curl http://192.168.80.10:8929/allan/pnv/raw/master/pnv.js > pnv.js
node pnv.js start

  ;;
 *)
# wifi()
# setup()
   ;;
esac

